prefixes = {'P1_L_solqual', 'P_L_solqual', 'M_L_solqual'};
solqual_scens = {'CPLEX12-CLS-solqual', 'CPLEX12-CORLAT-solqual', 'CPLEX12-MASS-solqual', 'CPLEX12-MIK-solqual', 'CPLEX12-Regions200-solqual'};
methodstrings = {'-pure-random-rfnSub10pars0.83333_10RFo-logM0eiI2ei3nLS10rR10000iS7ac0rF0.5cs2', '-rfnSub10pars0.83333_10RFo-logM0eiI2ei3nLS10rR10000iS7ac0rF0.5cs2'};

short_prefixes = {'P1', 'P100', 'S'};
short_methods = {'ROAR', 'SMAC'};
colours = {'b', 'k', 'r', 'g', 'k', 'c', 'r', 'k', 'g', 'c', 'b', 'r', 'k', 'g', 'c', 'b', 'r', 'k', 'g', 'c'};
styles = {'-', '--', ':', '.-', '-', '-', '--', '.-', ':', '-', '--', '.-', ':', '-', '--', '.-', ':', '-', '--', '.-'};
widths = [2,3,3,2,1,3,2,3,2,3,1,3,2,3,2,3,1,3,2,3,2,3,1,1];

for j=1:length(solqual_scens)
    figure;
    legends = {};
    hs = [];
    scen = solqual_scens{j};
    count = 1;
    count_used = 1;
    for i=1:length(prefixes)
    prefix  = prefixes{i};
        for k=1:length(methodstrings)
            methodstring = methodstrings{k};
            filename = ['/ubc/cs/project/arrow/hutter/altuning/matlab/threaded_FastRfLearning/out/westgrid/out/',prefix,'/',scen,methodstring,'/train_test_results.val'];
            %filename = ['/ubc/cs/project/arrow/hutter/altuning/matlab/threaded_FastRfLearning/out/wg100/out/',prefix,'/',scen,methodstring,'/train_test_results.val'];
            data = csvread(filename);
            idx = find(data(:,2)<100);
            if ~isempty(idx)
                hs(count_used) = semilogx(data(idx,1), data(idx,2), strcat(colours{count}, styles{count}), 'LineWidth', widths(count));
                hold on
                legends{count_used} = [short_prefixes{i},'-',short_methods{k}];
                count_used = count_used+1;
            end
            count = count+1;
        end
    end
    legend(hs, legends);
    title(scen);
    
    outfileprefix =  strcat(scen, '-vs10sequential');
    pdffilename = strcat(outfileprefix, '.pdf');
    if exist(pdffilename, 'file')
        delete(pdffilename);
    end
    export_fig(pdffilename);
    saveas(gca, strcat(outfileprefix, '.fig'), 'fig');
end

