%=== Evaluate true performance of parameters on instances.
function [actualObjTest, yAllTestAsVectorNoTrafo, trueMatrixNoTrafo, censAllTest] = getTruePerformance(func, dev_theta_idxs, instanceIdxToFill, options, worker_ids)
for i=1:length(instanceIdxToFill)
    seeds(i,:) = func.test_seeds(i);%instanceIdxToFill(i), 1:rep);
end
seeds = seeds(:);

dev_theta_idxs = dev_theta_idxs(:);
%=== First finish all runs for one configuration, then go to the next (same as SPO).
ThetaMatrixAsVector = repmat(dev_theta_idxs', [size(instanceIdxToFill,1)],1);
ThetaMatrixAsVector = ThetaMatrixAsVector(:);
instSeedsMatrixAsVector = repmat(instanceIdxToFill, [size(dev_theta_idxs,1), 1]);
seedsAsVector = repmat(seeds, [size(dev_theta_idxs,1), 1]);

tic;
bout(sprintf(strcat(['Evaluating function for every entry of the ', num2str(size(dev_theta_idxs,1)), ' by ', num2str(size(instanceIdxToFill,1)), ' matrix ...'])));

% [yAllTestAsVectorNoTrafo2, censAllTest2] = func.testFuncHandle(ThetaMatrixAsVector, instSeedsMatrixAsVector, seedsAsVector, func.cutoff * ones(length(instSeedsMatrixAsVector),1));
test_instance_flag = 1;
run_queue = [ThetaMatrixAsVector, instSeedsMatrixAsVector, func.cutoff * ones(length(instSeedsMatrixAsVector),1), seedsAsVector, zeros(length(instSeedsMatrixAsVector),1)];
while ~isempty(find(run_queue(:,5)<2))
    [run_queue, used_worker_ids, assigned_runs, output_filenames] = assignRunsToRubyWorkers(run_queue, options, func, worker_ids, test_instance_flag);
    
    bout(sprintf(strcat(['Waiting for workers...'])));
    tic;
    [finished_runs_with_results, output_filenames_to_delete, used_worker_ids, assigned_runs, output_filenames] = waitForRubyWorkers(1000000, used_worker_ids, assigned_runs, output_filenames, func);
    waitingTime = toc
    tic;
    deleteFilesAndReturnWhenFinished(output_filenames_to_delete)
    deleteTime = toc
    
    %=== Log finished runs to run_queue.
    for i=1:size(finished_runs_with_results,1)
        %= Find this run in run_queue and set it to "done" there.
        idx = intersect(intersect(find(run_queue(:,1)==finished_runs_with_results(i,1)), find(run_queue(:,2)==finished_runs_with_results(i,2))), ...
              intersect(find(run_queue(:,3)==finished_runs_with_results(i,3)), find(run_queue(:,4)==finished_runs_with_results(i,4))) );
%        assert(length(idx)==1, 'Asserting that we do not have exact copies of runs.');
%         assert(run_queue(idx, 5)==1, 'Run that just finished should have been marked as running!');
        run_queue(idx, 5) = 2; % mark as finished. Don't delete to not screw up indices.
        yAllTestAsVectorNoTrafo(idx,1) = finished_runs_with_results(i,5);
        censAllTest(idx,1) = finished_runs_with_results(i,6);
    end
end
% yAllTestAsVectorNoTrafo2-yAllTestAsVectorNoTrafo

if func.external
    yAllTestAsVectorNoTrafo = max(yAllTestAsVectorNoTrafo,0.005);
end

trueMatrixNoTrafo = reshape(yAllTestAsVectorNoTrafo', [size(instanceIdxToFill,1),size(dev_theta_idxs,1)])';
actualObjTest = combineRunObjectives(func.overallobj, trueMatrixNoTrafo, func.cutoff);

validationTimeForSingleModels = toc
bout(sprintf(strcat(['Evaluating function for every entry of the ', num2str(size(dev_theta_idxs,1)), ' by ', num2str(size(instanceIdxToFill,1)), ' matrix took ', num2str(validationTimeForSingleModels), ' seconds.'])));
clear ThetaMatrixAsVector instSeedsMatrixAsVector