function startWorkers(workspace_savedir, worker_ids, options)

% save([workspace_savedir, '/func.mat'], 'func');
outfolder = strcat(workspace_savedir, '/outputs/');
create_clean_directory(outfolder);

infolder = strcat(workspace_savedir, '/inputs/');
create_clean_directory(infolder);

logfolder = strcat(workspace_savedir, '/logs/');
create_clean_directory(logfolder);

worker_start_file = strcat(workspace_savedir, 'workers.txt');
starter_fid = fopen(worker_start_file, 'w');

for i=1:length(worker_ids)
    worker_id_string = strcat('worker_', num2str(worker_ids(i)));
%     func_filename = strcat(workspace_savedir, '/func.mat');
%     input_filename = strcat(infolder, '/', worker_id_string, '.mat');
%     output_filename = strcat(outfolder, '/', worker_id_string, '.mat');
%     cmd = ['./smbo_worker ', func_filename, ' ', input_filename, ' ', output_filename];

    input_filename = strcat(infolder, '/', worker_id_string, '.txt');
    output_filename = strcat(outfolder, '/', worker_id_string, '.txt');
    cmd = strcat(['ruby scripts/worker_al_run_configs_in_file_nodb.rb ', input_filename, ' ', output_filename]);

    if options.run_locally
        cmd = [cmd, ' & '];
        system(cmd);
    else
        fprintf(starter_fid, [cmd, '\n']);
    end    
end
if ~options.run_locally
    cmd = ['ruby scripts/run_commands_in_file.rb ', worker_start_file, ' ', pwd, ' 1 '];
    %system(cmd);
end

function create_clean_directory(dir)
cmd = ['rm -r -f ', dir];
system(cmd);
cmd = ['mkdir -p ', dir];
system(cmd);
