function [new_result_files, new_challenger_files, freed_worker_ids] = waitForNewResultFiles(workspace_savedir, iteration, free_worker_ids, num_workers)
freed_worker_ids = [];
folder = strcat(workspace_savedir, '/outputs/');

minNumRunsNeeded = num_workers;
%=== Wait until input exists.
while 1
    new_result_files = {};
    new_challenger_files = {};
    freed_worker_ids = [];
    pause(0.1);
    files = dir(folder);
    
    if length(files) < minNumRunsNeeded + 2
        continue;
    end
    
    for i=1:length(files) 
        if strcmp(files(i).name, '.') || strcmp(files(i).name, '..') 
            continue; 
        end
        if strcmp(files(i).name, 'new_challengers_result.mat') 
            new_challenger_files = [folder, '/', files(i).name];
        else
            new_result_files{end+1} = [folder, '/', files(i).name];
        end
        worker_id = strrep(files(i).name, '.mat', '');
        worker_id = strrep(worker_id, 'worker_', '');
        
        freed_worker_ids = [freed_worker_ids, str2num(worker_id)];
    end
    if length(new_result_files) + length(new_challenger_files) + length(free_worker_ids) >= minNumRunsNeeded
        break
    end
end

bout(['Iteration ', num2str(iteration), ': done waiting, got ', num2str(length(freed_worker_ids)), ' new result files.\n']);